use strict;
use warnings;
use IQ;

sub mgf_quant{
    my($spectra_folder,$par,$head,$plex,$area)=@_;
    my %params=%$par;
    my %header=%$head;
    my %plex=%$plex;
    my %area_name=%$area;
    ###################################################################
    opendir(DIR,$spectra_folder) || die "\nCannot open directory \"$spectra_folder\"\n";
    my @raw_files = readdir(DIR);
    closedir DIR;
    @raw_files=grep/\.mgf$/,@raw_files;
    print "Number of files to process:: ",scalar @raw_files,"\n";
    print "Type of area method:: \"$area_name{$params{Spectrum_area}}\"\n";

    foreach my $raw_input (@raw_files)
    {
        chomp $raw_input;
        open(IN,"$spectra_folder/$raw_input") or die $!;
        print "Processing file :\t$raw_input\n";
        my %spectra;##MS2=[array]
        my $out=$spectra_folder.'/'.$raw_input.'_'.$params{Spectrum_area}.'_'.$params{Tol_min}.'.tsv';
        $out=~s/\.mgf//;
	my $out1=$out;
	$out1=~s/\.tsv/_noquant\.tsv/;
        open(my $fh,">$out") or die $!;##without my the file handle $fh will fall into strict refs clause and will not open file    #code will die
        print "Output file opened as: $out\n";
	open(my $fh1,">$out1") or die $!;##without my the file handle $fh will fall into strict refs clause and will not open file    #code will die
        print "Output file no-Quant opened as: $out1\n";
        print $fh1 "Scan\tTitle\tRetention_time\tBase_Intensity\tPEPMASS\tCharge\tMSLevel\tPrevious Scan";
        print $fh "Scan\tTitle\tRetention_time\tBase_Intensity\tPEPMASS\tCharge\tMSLevel\tPrevious Scan";
       
        
        foreach my $tag(@{$header{$params{Label_type}}{$params{Plex}}})
        {
            #print $fh "\t$tag-Area\t$tag-Error\t$tag-Peak_Max\t$tag-Ratio\t$tag-Ratio_error";
            print $fh "\t$tag/$params{Base_reporter}";
        }
        foreach my $tag(@{$header{$params{Label_type}}{$params{Plex}}})
        {
            print $fh "\t$tag/$params{Base_reporter}-Err";
        }
        foreach my $tag(@{$header{$params{Label_type}}{$params{Plex}}})
        {
            print $fh "\t$tag","_Peak_Max";
        }
        foreach my $tag(@{$header{$params{Label_type}}{$params{Plex}}})
        {
            print $fh "\t$tag","_Area";
        }
        foreach my $tag(@{$header{$params{Label_type}}{$params{Plex}}})
        {
            print $fh "\t$tag","_Error";
        }
        print $fh "\n";
	print $fh1 "\n";
        my $cnt_spec=0;  
        #spectrum wise
        #################################################################################################
            #read file attributes
            #create hash for title, rt, charge, m/z, intensity (NA for wherever charge and intensity is not given)
            #read the global hash for label method and filter only peak values in that range +- tol range
            #save filtered values in a hash and pass it to spectrum_quantitator subroutine
        #################################################################################################
        while (<IN>)
        {
                chomp $_;
                if ($_=~m/^END IONS/)
                {
                    #checking if charge is there or not and then reassigning
                    if (!exists($spectra{Z}))
                    {
                        $spectra{Z}='NA';
                    }
                    if (!exists($spectra{RT}))
                    {
                        $spectra{RT}='NA';
                    }
                    if (exists $spectra{MS2}) #if no peaks are available the subroutine will not be called
                    {
			$spectra{MSLevel}='NA';
			$spectra{PrevScan}='NA';
                        #if ((scalar (@{$spectra{MS2}}))> $params{min_reporters})
                        #{
                        my($spectra_hashref,$area_hashref,$rep_count)= spectrum_quantitator(\%spectra,\%params,\%plex);
                        if ($rep_count>=$params{min_reporters})
                        {
                            print_spec($cnt_spec,$spectra_hashref,$area_hashref,$fh);
                        }
                    }
		    else
		    {
		        print $fh1 "$cnt_spec\t$spectra{TITLE}\t$spectra{RT}\t$spectra{INT}\t$spectra{MZ}\t$spectra{Z}\n";
		    }
                    %spectra=();
                }
                elsif ($_ =~m/^BEGIN IONS/)
                {
                    $cnt_spec++;
		    next;
                }
                elsif ($_=~m/^TITLE=(.+)/)
                {
                    my $title=$1;
                    $spectra{TITLE}=$title;
                }
                elsif ($_=~m/^RTINSECONDS=(.+)/)
                {
                    my $rt=$1;
                    $spectra{RT}=$rt;
                }
                elsif ($_=~m/^CHARGE=(.+)/)
                {
                    my $charge=$1;
                    $spectra{Z}=$charge;
                }
                elsif ($_=~m/^PEPMASS=(.+)/)
                {
                    my $mass=$1;
                    my($mz,$int)=(split/\s+/,$mass)[0,1];## NA if intensity not given
                    $spectra{MZ}=$mz;
                    if (!defined $int)
                    {
                       $spectra{INT}="NA";
                    }
                    else
                    {
                        $spectra{INT}=$int;
                    }
                    
                }
                elsif($_=~m/^\d+/)
                {
                    my @temp1=split/\s+/,$_;                
                    ################################################################################################
                    #temp1[0] contains m/z values, $plex{$params{Label_type}}{$params{Plex}}[0] contains first value of the reporter tag
                    #$params{Tol_min} and $params{Tol_max} contain tolerance range by the user in params.txt and
                    #$plex{$params{Label_type}}{$params{Plex}}[-1] contains last tag value of reporter ions
                    if ($params{Tol_unit} eq "Da")
		    {
			# picking reporter peaks within window peak +- tol barring 120
			if ($temp1[0] >= ($plex{$params{Label_type}}{$params{Plex}}[0] - $params{Tol_min}))
			{
			    if($temp1[0] <= ($plex{$params{Label_type}}{$params{Plex}}[-1] + $params{Tol_max}))
			    {
			        if ($params{Label_type} eq "iTRAQ" && $temp1[0]=~m/^120/)
			        {
			            #skip phenylalanine immonium ion
			        }
			        else
			        {
			            push(@{$spectra{MS2}},$_);#keys->MS2 value->[(m/z int),(m/z int)....]
			        }
			    }
			}
                    }
		    else#ppm
		    {
			if ($temp1[0] >= ($plex{$params{Label_type}}{$params{Plex}}[0] - (($plex{$params{Label_type}}{$params{Plex}}[0]*$params{Tol_min})/1000000)))
			{
			    if($temp1[0] <= ($plex{$params{Label_type}}{$params{Plex}}[-1] + (($plex{$params{Label_type}}{$params{Plex}}[-1]*$params{Tol_max})/1000000)))
			    {
			        if ($params{Label_type} eq "iTRAQ" && $temp1[0]=~m/^120/)
			        {
			            #skip phenylalanine immonium ion
			        }
			        else
			        {
			            push(@{$spectra{MS2}},$_);#keys->MS2 value->[(m/z int),(m/z int)....]
			        }
			        
			    }
			}
		    }
                }   
            }
            close IN;
            close $fh;
	    close $fh1;
    }

}
1;